
import 'package:crud_service/Env/DataDecoder.dart';

enum EnvType {
  develop,
  demo,
  stag,
  product,
  custom
}


class ServiceConfig {
  static ServiceConfig _shared;

  static ServiceConfig get shared => _getSharedManager();


  static ServiceConfig _getSharedManager() {
    if (_shared == null) {
      _shared = ServiceConfig();
    }
    return _shared;
  }

  EnvType current = EnvType.develop;
  Map<String, String> configs = new Map<String, String>();
  Map<String, String> fileConfigs = new Map<String, String>();
  Map<String, String> commonParameter = new Map<String, String>();

  DataDecoder decoder = DataDecoder();

  String baseUrl() {
    switch(current) {
      case EnvType.develop:
        return configs["develop"];
        break;
      case EnvType.demo:
        return configs["demo"];
        break;
      case EnvType.stag:
        return configs["stag"];
        break;
      case EnvType.product:
        return configs["product"];
        break;
      case EnvType.custom:
        return configs["custom"];
        break;
    }
  }

  String fileUrl() {
    switch(current) {
      case EnvType.develop:
        return fileConfigs["develop"];
        break;
      case EnvType.demo:
        return fileConfigs["demo"];
        break;
      case EnvType.stag:
        return fileConfigs["stag"];
        break;
      case EnvType.product:
        return fileConfigs["product"];
        break;
      case EnvType.custom:
        return fileConfigs["custom"];
        break;
    }
  }
}