
import 'dart:convert';
import 'package:dio/dio.dart';
import 'package:crud_service/Model/RequestC.dart';
import 'package:crud_service/Model/RequestD.dart';
import 'package:crud_service/Env/ServiceConfig.dart';
import 'package:crud_service/Model/crud_entity.dart';
import 'package:crud_service/Model/request_entity.dart';

class BaseService<T extends CrudEntity> {
  static Dio dio = new Dio(BaseOptions(baseUrl: ServiceConfig.shared.baseUrl()));
  static JsonCodec json = const JsonCodec();


  Future<dynamic> post(String path, RequestEntity data) async {
    var r = await BaseService.dio.post(path, data: data.toJson());
    var resultJson = r.data["result"];
    return resultJson;
  }

  Future<RequestEntity> createRequest() async {
    var request = RequestEntity();

    var requestD = RequestD();
    request.d = requestD;

    List<RequestC> cArray = new List<RequestC>();
    var parameter = ServiceConfig.shared.commonParameter;
    for (String key in parameter.keys) {
      var value = parameter[key];
      cArray.add(RequestC(key, value));
    }
    requestD.c = cArray;
    return request;
  }
}