
import 'package:crud_service/Model/RequestField.dart';
import 'package:flutter/cupertino.dart';
import 'package:crud_service/Env/ServiceConfig.dart';
import 'package:crud_service/Model/RequestFilter.dart';
import 'package:crud_service/Model/RequestPage.dart';
import 'package:crud_service/Model/RequestSearch.dart';
import 'package:crud_service/Model/RequestSort.dart';
import 'package:crud_service/Model/crud_entity.dart';
import 'package:crud_service/Model/request_entity.dart';
import 'package:crud_service/Service/BaseService.dart';

class ListService<T extends CrudEntity> extends BaseService<T> {
  Future<List<T>> list(String path, RequestPage page, {List<RequestFilter> filters, List<RequestSort> sorts, RequestSearch search, List<RequestField> fields}) async {
    RequestEntity request = await createRequest();

    request.d.filters = filters;
    request.d.page = page;
    request.d.sorts = sorts;
    request.d.search = search;
    request.d.fields = fields;

    var resultJson = await post(path, request);
    return ServiceConfig.shared.decoder.fromJsonAsT<List<T>>(resultJson);
  }

  Future<List<T>> listObj(String path, T obj, {List<RequestField> fields}) async {
    RequestEntity request = await createRequest();

    request.obj = obj;
    request.d.fields = fields;

    var resultJson = await post(path, request);
    return ServiceConfig.shared.decoder.fromJsonAsT<List<T>>(resultJson);
  }
}
