
import 'package:flutter/cupertino.dart';
import 'package:crud_service/Env/ServiceConfig.dart';
import 'package:crud_service/Model/crud_entity.dart';
import 'package:crud_service/Model/request_entity.dart';
import 'package:crud_service/Service/BaseService.dart';

class ShowService<T extends CrudEntity> extends BaseService<T> {

  Future<T> show(String path, {T obj, String idField}) async {
    RequestEntity request = await createRequest();

    request.obj = obj;
    request.d.idField = idField;

    var resultJson = await post(path, request) as Map<String, dynamic>;
    return ServiceConfig.shared.decoder.fromJsonAsT<T>(resultJson);
  }
}